#include <gtk/gtk.h>

#include "bitmap.xbm"


static gboolean expose_event(GtkWidget *area, GdkEventExpose *event)
{
static GdkPixmap *pixmap;

	if ( !pixmap ) {
		pixmap = gdk_pixmap_create_from_data(
							area->window,
							bitmap_bits,
							bitmap_width,
							bitmap_height,
							-1,
							&area->style->light[GTK_STATE_NORMAL],
							&area->style->dark[GTK_STATE_NORMAL]
		);
		g_return_if_fail(pixmap!=NULL);
	}

	gdk_draw_pixmap(
				area->window,
				area->style->black_gc,
				pixmap,
				event->area.x,
				event->area.y,
				event->area.x,
				event->area.y,
				event->area.width,
				event->area.height
	);

	return TRUE;
}

int main(int argc, char **argv)
{
GtkWidget *window;
GtkWidget *area;

	gtk_init(&argc, &argv);

	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_signal_connect(GTK_OBJECT(window), "delete-event", (GtkSignalFunc)gtk_main_quit, 0);

	area = gtk_drawing_area_new();
	gtk_widget_set_usize(area, bitmap_width,bitmap_height);
	gtk_container_add(GTK_CONTAINER(window), area);
	gtk_signal_connect(GTK_OBJECT(area), "expose-event", (GtkSignalFunc)expose_event, 0);

	gtk_widget_show_all(window);

	gtk_main();

	return 0;
}
